#include "preferences.h"
#include "QFile"
#include <QDebug>
#include <QTextStream>
#include <QString>
#include <QIODevice>
#include <QVector>
#include <iterator>
#include <QVariant>

preferences::preferences()
{

    QFile file("alarm.conf");
    if( !file.exists() ){
        qWarning() << "does not exist";
        //lets created!
        QFile file( "alarm.conf" );
        QTextStream stream( &file );
        if ( file.open( QIODevice::WriteOnly ) ) {
                stream << "warning.wav" << "\n";
                stream << "12:00" << "\n";
                stream << "1" << "\n";
                stream << "1" << "\n";
                stream << "8" << "\n";
            qWarning() << "OK, created!";
            file.close();
        }
    }

    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
             return;

    QTextStream in(&file);
    while (!in.atEnd()) {
        vector.append(in.readLine());
    }

    file.close();
}

QString preferences::get(int key)
{
    return vector.value(key);
}


void preferences::set(int key, QString value)
{
    //set
    vector[key] = value;
    //save...
    write();
}

//GETS
QString preferences::getSoundFileName()
{
    return vector.value(FILENAME);
}

QString preferences::getTime()
{
    return vector.value(TIME);
}

bool preferences::getStoppBySound()
{
    if(vector.value(SOUND) == "1")
        return true;
    else
        return false;
}

bool preferences::getStoppByAccelerometer()
{
    if(vector.value(ACCELEROMETER) == "1")
        return true;
    else
        return false;
}

int preferences::getSensitivityAccelerometer()
{
    QVariant v(vector.value(ACCELEROMETERSEN));
    return v.toInt();
}

//SETS
void preferences::setSoundFileName(QString value)
{
    vector[FILENAME] = value;
    write();
}

void preferences::setTime(QString value)
{
    vector[TIME] = value;
    write();
}

void preferences::setStoppBySound(bool sound)
{
    if(sound)
        vector[SOUND] = "1";
    else
        vector[SOUND] = "0";
    write();
}

void preferences::setStoppByAccelerometer(bool accelerometer)
{
    if(accelerometer)
        vector[ACCELEROMETER] = "1";
    else
        vector[ACCELEROMETER] = "0";
    write();
}

void preferences::setSensitivityAccelerometer(int sensitivity)
{
    QVariant v(sensitivity);
    vector[ACCELEROMETERSEN] = v.toString();
    write();
}

void preferences::write(){
    QFile file( "alarm.conf" );
    QTextStream stream( &file );
    if ( file.open( QIODevice::WriteOnly ) ) {
        for ( int count=0; count < 5; count++ )
            stream << vector[count] << "\n";
        file.close();
    }
}
